/*---------------------------------------------------------------------------*
 *
 * Project:	fXPlayMidi
 *
 * $RCSfile: child.c,v $
 * $Date: 1997/04/26 08:14:57 $
 * $Author: klmcw $
 * $Revision: 1.4 $
 *
 *---------------------------------------------------------------------------*
 * $Log: child.c,v $
 * Revision 1.4  1997/04/26 08:14:57  klmcw
 * Removed support for Device option.
 *
 * Revision 1.3  1996/04/19 13:14:25  klmcw
 * Needed stdlib.h
 *
 * Revision 1.2  1996/03/02 19:59:58  klmcw
 * Added #includes per -Wall suggestions -- better lint than lint!
 *
 * Revision 1.1  1996/02/26 02:22:58  klmcw
 * Initial revision
 *
 *---------------------------------------------------------------------------*/

/*---------------------------------------------------------------------------*/
#include <limits.h>
#include <signal.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/wait.h>
#include <unistd.h>

#include "fXPlayMidi.h"
#include "child.h"
#include "options.h"

/*-------------------------------------------------------*/

static void child_Sig(int);

/*-------------------------------------------------------*/
void
childPlay(const char *File)
{
  static char Cmd[_POSIX_PATH_MAX+20];

  signal(SIGCHLD, child_Sig);
  signal(SIGTERM, child_Sig);
  signal(SIGUSR1, child_Sig);

  setpgrp();

  memset(Cmd, '\0', sizeof(Cmd));
  sprintf(Cmd, "%s %s", optionsBaseCmdGet(), File);

  system(Cmd);
  _exit(0);
}
/*---------------------------------------------------------------------------*/
static void
child_Sig(int sig)
{
  wait(NULL);
}
/*---------------------------------------------------------------------------*/
